Subject: Re: bug#7887: Emacs will render some fonts under Mac OS X one pixel too tall (patch supplied)

From: Jan Djärv <[email-masked]>
Date: Sat, 29 Jan 2011 11:39:09 +0100

Anders Lindgren skrev 2011-01-25 18.18:

>
> My original suggesten simply said that anything in the range -2.0 -
> -2.0001 should be treated as -2. The motivation behind this is that
> often a floating-point error is only in the lowest bit or bits. (In
> the case I found, the bits that were set corresponds to the least
> significant mantissa bits of a 32 bit floating-point number, even
> though the number had been converted to 64 bit number along the way.)
>

If it only to handle fp errors, then I guess 0.0001 is OK.  Patch checked in.
I don't have any fonts to test with, so if you can confirm that it is fixed, 
that would be great.

Thanks,

	Jan D.

> On Tue, Jan 25, 2011 at 5:12 PM, Jan Djärv <[email-masked]> wrote:
>> > Sounds like a job for round then.
>> >
>> >        Jan D.
>> >
>> >
>> > Anders Lindgren skrev 2011-01-25 15.45:
>>> >>
>>> >> No, that won't work. Descents are always negative, "floor" is used to
>>> >> treat, for example, -2.5 as -3.0, to avoid clipping. The problem is
>>> >> that is also converts -2.000001 to -3.
>>> >>
>>> >> What I suggested was that we continue to round -2.5 down to -3, but
>>> >> round values very close to -2.0 up to -2.
>>> >>
>>> >> I don't know if this is a general problem, only related to FontForge
>>> >> (an open-source font editor). If it's only related to FontForge, then
>>> >> another solution would be to fix it instead of Emacs.
>>> >>
>>> >>     -- Anders
>>> >>
>>> >>